Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ImmutableMultimap<K,V>

    java.lang.Object
      com.google.common.collect.ImmutableMultimap<K,V>

All Implemented Interfaces:
  Multimap<K,V>, Serializable

Direct Known Subclasses:
  ImmutableListMultimap, ImmutableSetMultimap

    @GwtCompatible(emulated=true)
    public abstract class ImmutableMultimap<K,V>

extends Object
implements Multimap<K,V>, Serializable

An immutable `Multimap`. Does not permit null keys or values.

Unlike `Multimaps.unmodifiableMultimap(Multimap)`, which is a view of a separate multimap which can still change, an instance of `ImmutableMultimap` contains its own data and will never change. `ImmutableMultimap` is convenient for `public static final` multimaps ("constant multimaps") and also lets you easily make a "defensive copy" of a multimap provided to your class by a caller.

Note: Although this class is not final, it cannot be subclassed as it has no public or protected constructors. Thus, instances of this class are guaranteed to be immutable.

In addition to methods defined by `Multimap`, an `inverse()` method is also supported.

See the Guava User Guide article on immutable collections.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Jared Levy
See Also:
  Serialized Form

Nested Class Summary
`static class` | `ImmutableMultimap.Builder<K,V>` A builder for creating immutable multimap instances, especially `public static final` multimaps ("constant multimaps").

Method Summary
`ImmutableMap<K,Collection<V>>` | `asMap()` Returns an immutable map that associates each key with its corresponding values in the multimap.
`static
`<K,V> ImmutableMultimap.Builder<K,V>`
` | `builder()` Returns a new builder.
`void` | `clear()` Guaranteed to throw an exception and leave the multimap unmodified.
`boolean` | `containsEntry(Object key, Object value)` Returns `true` if the multimap contains the specified key-value pair.
`boolean` | `containsKey(Object key)` Returns `true` if the multimap contains any values for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if the multimap contains the specified value for any key.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `copyOf(Multimap<? extends K,? extends V> multimap)` Returns an immutable multimap containing the same mappings as `multimap`.
`ImmutableCollection<Map.Entry<K,V>>` | `entries()` Returns an immutable collection of all key-value pairs in the multimap.
`boolean` | `equals(Object object)` Compares the specified object with this multimap for equality.
`abstract ImmutableCollection<V>` | `get(K key)` Returns an immutable collection of the values for the given key.
`int` | `hashCode()` Returns the hash code for this multimap.
`abstract ImmutableMultimap<V,K>` | `inverse()` Returns an immutable multimap which is the inverse of this one.
`boolean` | `isEmpty()` Returns `true` if the multimap contains no key-value pairs.
`ImmutableMultiset<K>` | `keys()` Returns a collection, which may contain duplicates, of all keys.
`ImmutableSet<K>` | `keySet()` Returns an immutable set of the distinct keys in this multimap.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of()` Returns an empty multimap.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1)` Returns an immutable multimap containing a single entry.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4, K k5, V v5)` Returns an immutable multimap containing the given entries, in order.
`boolean` | `put(K key, V value)` Guaranteed to throw an exception and leave the multimap unmodified.
`boolean` | `putAll(K key, Iterable<? extends V> values)` Guaranteed to throw an exception and leave the multimap unmodified.
`boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Guaranteed to throw an exception and leave the multimap unmodified.
`boolean` | `remove(Object key, Object value)` Guaranteed to throw an exception and leave the multimap unmodified.
`ImmutableCollection<V>` | `removeAll(Object key)` Guaranteed to throw an exception and leave the multimap unmodified.
`ImmutableCollection<V>` | `replaceValues(K key, Iterable<? extends V> values)` Guaranteed to throw an exception and leave the multimap unmodified.
`int` | `size()` Returns the number of key-value pairs in the multimap.
`String` | `toString()`
`ImmutableCollection<V>` | `values()` Returns an immutable collection of the values in this multimap.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### of

    public static <K,V> ImmutableMultimap<K,V> of()

  Returns an empty multimap.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1)

  Returns an immutable multimap containing a single entry.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1,
                                                  K k2,
                                                  V v2)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1,
                                                  K k2,
                                                  V v2,
                                                  K k3,
                                                  V v3)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1,
                                                  K k2,
                                                  V v2,
                                                  K k3,
                                                  V v3,
                                                  K k4,
                                                  V v4)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1,
                                                  K k2,
                                                  V v2,
                                                  K k3,
                                                  V v3,
                                                  K k4,
                                                  V v4,
                                                  K k5,
                                                  V v5)

  Returns an immutable multimap containing the given entries, in order.

### builder

    public static <K,V> ImmutableMultimap.Builder<K,V> builder()

  Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableMultimap.Builder` constructor.

### copyOf

    public static <K,V> ImmutableMultimap<K,V> copyOf(Multimap<? extends K,? extends V> multimap)

  Returns an immutable multimap containing the same mappings as `multimap`. The generated multimap's key and value orderings correspond to the iteration ordering of the `multimap.asMap()` view.

  Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

  Throws:
    `NullPointerException` - if any key or value in `multimap` is null

### removeAll

    public ImmutableCollection<V> removeAll(Object key)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `removeAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.
  Throws:
    `UnsupportedOperationException` - always

### replaceValues

    public ImmutableCollection<V> replaceValues(K key,
                                                Iterable<? extends V> values)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `replaceValues` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.
  Throws:
    `UnsupportedOperationException` - always

### clear

    public void clear()

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `clear` in interface `Multimap<K,V>`
  Throws:
    `UnsupportedOperationException` - always

### get

    public abstract ImmutableCollection<V> get(K key)

  Returns an immutable collection of the values for the given key. If no mappings in the multimap have the provided key, an empty immutable collection is returned. The values are in the same order as the parameters used to build this multimap.

  Specified by:
    `get` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### inverse

    @Beta
    public abstract ImmutableMultimap<V,K> inverse()

  Returns an immutable multimap which is the inverse of this one. For every key-value mapping in the original, the result will have a mapping with key and value reversed.

  Since:
    11.0

### put

    public boolean put(K key,
                       V value)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `put` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `value` - value to store in the multimap
  Returns:
    `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair and doesn't allow duplicates
  Throws:
    `UnsupportedOperationException` - always

### putAll

    public boolean putAll(K key,
                          Iterable<? extends V> values)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    `true` if the multimap changed
  Throws:
    `UnsupportedOperationException` - always

### putAll

    public boolean putAll(Multimap<? extends K,? extends V> multimap)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `multimap` - mappings to store in this multimap
  Returns:
    `true` if the multimap changed
  Throws:
    `UnsupportedOperationException` - always

### remove

    public boolean remove(Object key,
                          Object value)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `remove` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entry to remove from the multimap
    `value` - value of entry to remove the multimap
  Returns:
    `true` if the multimap changed
  Throws:
    `UnsupportedOperationException` - always

### containsEntry

    public boolean containsEntry(@Nullable
                                 Object key,
                                 @Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified key-value pair.

  Specified by:
    `containsEntry` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
    `value` - value to search for in multimap

### containsKey

    public boolean containsKey(@Nullable
                               Object key)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains any values for the specified key.

  Specified by:
    `containsKey` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified value for any key.

  Specified by:
    `containsValue` in interface `Multimap<K,V>`
  Parameters:
    `value` - value to search for in multimap

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains no key-value pairs.

  Specified by:
    `isEmpty` in interface `Multimap<K,V>`

### size

    public int size()

  Description copied from interface: `Multimap`
  Returns the number of key-value pairs in the multimap.

  Specified by:
    `size` in interface `Multimap<K,V>`

### equals

    public boolean equals(@Nullable
                          Object object)

  Description copied from interface: `Multimap`
  Compares the specified object with this multimap for equality. Two multimaps are equal when their map views, as returned by `Multimap.asMap()`, are also equal.

  In general, two multimaps with identical key-value mappings may or may not be equal, depending on the implementation. For example, two `SetMultimap` instances with the same key-value mappings are equal, but equality of two `ListMultimap` instances depends on the ordering of the values for each key.

  A non-empty `SetMultimap` cannot be equal to a non-empty `ListMultimap`, since their `Multimap.asMap()` views contain unequal collections as values. However, any two empty multimaps are equal, because they both have empty `Multimap.asMap()` views.

  Specified by:
    `equals` in interface `Multimap<K,V>`
  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Description copied from interface: `Multimap`
  Returns the hash code for this multimap.

  The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

  Specified by:
    `hashCode` in interface `Multimap<K,V>`
  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### keySet

    public ImmutableSet<K> keySet()

  Returns an immutable set of the distinct keys in this multimap. These keys are ordered according to when they first appeared during the construction of this multimap.

  Specified by:
    `keySet` in interface `Multimap<K,V>`
  Returns:
    the collection of distinct keys

### asMap

    public ImmutableMap<K,Collection<V>> asMap()

  Returns an immutable map that associates each key with its corresponding values in the multimap.

  Specified by:
    `asMap` in interface `Multimap<K,V>`
  Returns:
    a map view from a key to its collection of values

### entries

    public ImmutableCollection<Map.Entry<K,V>> entries()

  Returns an immutable collection of all key-value pairs in the multimap. Its iterator traverses the values for the first key, the values for the second key, and so on.

  Specified by:
    `entries` in interface `Multimap<K,V>`
  Returns:
    collection of map entries consisting of key-value pairs

### keys

    public ImmutableMultiset<K> keys()

  Returns a collection, which may contain duplicates, of all keys. The number of times a key appears in the returned multiset equals the number of mappings the key has in the multimap. Duplicate keys appear consecutively in the multiset's iteration order.

  Specified by:
    `keys` in interface `Multimap<K,V>`
  Returns:
    a multiset with keys corresponding to the distinct keys of the multimap and frequencies corresponding to the number of values that each key maps to

### values

    public ImmutableCollection<V> values()

  Returns an immutable collection of the values in this multimap. Its iterator traverses the values for the first key, the values for the second key, and so on.

  Specified by:
    `values` in interface `Multimap<K,V>`
  Returns:
    collection of values, which may include the same value multiple times if it occurs in multiple mappings

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2012. All Rights Reserved.